/*!
 * GeoFire is an open-source library that allows you to store and query a set
 * of keys based on their geographic location. At its heart, GeoFire simply
 * stores locations with string keys. Its main benefit, however, is the
 * possibility of retrieving only those keys within a given geographic area -
 * all in realtime.
 *
 * GeoFire 4.0.0
 * https://github.com/firebase/geofire-js/
 * License: MIT
 */
var GeoFire=function(){"use strict";function e(e,n){return y(e),v(n),{".priority":n,g:n,l:e}}function n(e){if(null!==e&&e.hasOwnProperty("l")&&Array.isArray(e.l)&&2===e.l.length)return e.l;throw new Error("Unexpected GeoFire location object encountered: "+JSON.stringify(e))}var t=function(e){if(this.cancel=function(){"undefined"!=typeof n&&(n(),n=void 0)},"function"!=typeof e)throw new Error("callback must be a function");var n=e},r=function(t){if(this.ref=function(){return r},this.set=function(n,t){var i;if("string"==typeof n&&0!==n.length)i={},i[n]=t;else{if("object"!=typeof n)throw new Error("keyOrLocations must be a string or a mapping of key - location pairs.");if("undefined"!=typeof t)throw new Error("The location argument should not be used if you pass an object to set().");i=n}var o={};return Object.keys(i).forEach(function(n){d(n);var t=i[n];if(null===t)o[n]=null;else{y(t);var r=b(t);o[n]=e(t,r)}}),r.update(o)},this.get=function(e){return d(e),r.child(e).once("value").then(function(e){var t=e.val();return null===t?null:n(t)})},this.remove=function(e){return this.set(e,null)},this.query=function(e){return new j(r,e)},"[object Object]"!==Object.prototype.toString.call(t))throw new Error("firebaseRef must be an instance of Firebase");var r=t};r.distance=function(e,n){y(e),y(n);var t=6371,r=m(n[0]-e[0]),i=m(n[1]-e[1]),o=Math.sin(r/2)*Math.sin(r/2)+Math.cos(m(e[0]))*Math.cos(m(n[0]))*Math.sin(i/2)*Math.sin(i/2),a=2*Math.atan2(Math.sqrt(o),Math.sqrt(1-o));return t*a};var i=10,o="0123456789bcdefghjkmnpqrstuvwxyz",a=40007860,u=110574,f=5,c=22*f,l=6378137,s=.00669447819799,h=1e-12;Math.log2=Math.log2||function(e){return Math.log(e)/Math.log(2)};var d=function(e){var n;if("string"!=typeof e?n="key must be a string":0===e.length?n="key cannot be the empty string":1+i+e.length>755?n="key is too long to be stored in Firebase":/[\[\].#$\/\u0000-\u001F\u007F]/.test(e)&&(n="key cannot contain any of the following characters: . # $ ] [ /"),"undefined"!=typeof n)throw new Error("Invalid GeoFire key '"+e+"': "+n)},y=function(e){var n;if(Array.isArray(e))if(2!==e.length)n="expected array of length 2, got length "+e.length;else{var t=e[0],r=e[1];"number"!=typeof t||isNaN(t)?n="latitude must be a number":-90>t||t>90?n="latitude must be within the range [-90, 90]":"number"!=typeof r||isNaN(r)?n="longitude must be a number":(-180>r||r>180)&&(n="longitude must be within the range [-180, 180]")}else n="location must be an array";if("undefined"!=typeof n)throw new Error("Invalid GeoFire location '"+e+"': "+n)},v=function(e){var n;if("string"!=typeof e)n="geohash must be a string";else if(0===e.length)n="geohash cannot be the empty string";else for(var t=0,r=e.length;r>t;++t)-1===o.indexOf(e[t])&&(n='geohash cannot contain "'+e[t]+'"');if("undefined"!=typeof n)throw new Error("Invalid GeoFire geohash '"+e+"': "+n)},g=function(e,n){if("object"!=typeof e)throw new Error("query criteria must be an object");if("undefined"==typeof e.center&&"undefined"==typeof e.radius)throw new Error("radius and/or center must be specified");if(n&&("undefined"==typeof e.center||"undefined"==typeof e.radius))throw new Error("query criteria for a new query must contain both a center and a radius");for(var t=Object.keys(e),r=t.length,i=0;r>i;++i){var o=t[i];if("center"!==o&&"radius"!==o)throw new Error("Unexpected attribute '"+o+"'' found in query criteria")}if("undefined"!=typeof e.center&&y(e.center),"undefined"!=typeof e.radius){if("number"!=typeof e.radius||isNaN(e.radius))throw new Error("radius must be a number");if(e.radius<0)throw new Error("radius must be greater than or equal to 0")}},m=function(e){if("number"!=typeof e||isNaN(e))throw new Error("Error: degrees must be a number");return e*Math.PI/180},b=function(e,n){if(y(e),"undefined"!=typeof n){if("number"!=typeof n||isNaN(n))throw new Error("precision must be a number");if(0>=n)throw new Error("precision must be greater than 0");if(n>22)throw new Error("precision cannot be greater than 22");if(Math.round(n)!==n)throw new Error("precision must be an integer")}n=n||i;for(var t={min:-90,max:90},r={min:-180,max:180},a="",u=0,f=0,c=1;a.length<n;){var l=c?e[1]:e[0],s=c?r:t,h=(s.min+s.max)/2;l>h?(u=(u<<1)+1,s.min=h):(u=(u<<1)+0,s.max=h),c=!c,4>f?f++:(f=0,a+=o[u],u=0)}return a},p=function(e,n){var t=m(n),r=Math.cos(t)*l*Math.PI/180,i=1/Math.sqrt(1-s*Math.sin(t)*Math.sin(t)),o=r*i;return h>o?e>0?360:0:Math.min(360,e/o)},w=function(e,n){var t=p(e,n);return Math.abs(t)>1e-6?Math.max(1,Math.log2(360/t)):1},k=function(e){return Math.min(Math.log2(a/2/e),c)},M=function(e){if(180>=e&&e>=-180)return e;var n=e+180;return n>0?n%360-180:180- -n%360},E=function(e,n){var t=n/u,r=Math.min(90,e[0]+t),i=Math.max(-90,e[0]-t),o=2*Math.floor(k(n)),a=2*Math.floor(w(n,r))-1,f=2*Math.floor(w(n,i))-1;return Math.min(o,a,f,c)},x=function(e,n){var t=n/u,r=Math.min(90,e[0]+t),i=Math.max(-90,e[0]-t),o=p(n,r),a=p(n,i),f=Math.max(o,a);return[[e[0],e[1]],[e[0],M(e[1]-f)],[e[0],M(e[1]+f)],[r,e[1]],[r,M(e[1]-f)],[r,M(e[1]+f)],[i,e[1]],[i,M(e[1]-f)],[i,M(e[1]+f)]]},O=function(e,n){v(e);var t=Math.ceil(n/f);if(e.length<t)return[e,e+"~"];e=e.substring(0,t);var r=e.substring(0,e.length-1),i=o.indexOf(e.charAt(e.length-1)),a=n-r.length*f,u=f-a,c=i>>u<<u,l=c+(1<<u);return l>31?[r+o[c],r+"~"]:[r+o[c],r+o[l]]},_=function(e,n){y(e);var t=Math.max(1,E(e,n)),r=Math.ceil(t/f),i=x(e,n),o=i.map(function(e){return O(b(e,r),t)});return o.filter(function(e,n){return!o.some(function(t,r){return n>r&&e[0]===t[0]&&e[1]===t[1]})})},j=function(e,o){function a(e,n,t,r){O[e].forEach(function(e){"undefined"==typeof t||null===t?e(n,null,null):e(n,t,r)})}function u(){O.ready.forEach(function(e){e()})}function f(e){var n=e.split(":");if(2!==n.length)throw new Error("Invalid internal state! Not a valid geohash query: "+e);return n}function c(e){if(2!==e.length)throw new Error("Not a valid geohash query: "+e);return e[0]+":"+e[1]}function l(e,n){var t=x.orderByChild("g").startAt(e[0]).endAt(e[1]);t.off("child_added",n.childAddedCallback),t.off("child_removed",n.childRemovedCallback),t.off("child_changed",n.childChangedCallback),t.off("value",n.valueCallback)}function s(){for(var e=Object.keys(I),n=e.length,t=0;n>t;++t){var r=e[t],i=I[r];if(i.active===!1){var o=f(r);l(o,i),delete I[r]}}for(e=Object.keys(C),n=e.length,t=0;n>t;++t){var a=e[t];if(!d(C[a].geohash)){if(C[a].isInQuery)throw new Error("Internal State error, trying to remove location that is still in query");delete C[a]}}F=!1,null!==q&&(clearTimeout(q),q=null)}function h(e,n){y(n);var t,o,u=C.hasOwnProperty(e)?C[e].isInQuery:!1,f=C.hasOwnProperty(e)?C[e].location:null;t=r.distance(n,A),o=Q>=t,C[e]={location:n,distanceFromCenter:t,isInQuery:o,geohash:b(n,i)},o&&!u?a("key_entered",e,n,t):!o||null===f||n[0]===f[0]&&n[1]===f[1]?!o&&u&&a("key_exited",e,n,t):a("key_moved",e,n,t)}function d(e){for(var n=Object.keys(I),t=n.length,r=0;t>r;++r){var i=n[r];if(I.hasOwnProperty(i)){var o=f(i);if(e>=o[0]&&e<=o[1])return!0}}return!1}function v(e,n){var t=C[e];if(delete C[e],"undefined"!=typeof t&&t.isInQuery){var i=n?r.distance(n,A):null;a("key_exited",e,n,i)}}function m(e){h(e.key(),n(e.val()))}function p(e){h(e.key(),n(e.val()))}function w(e){var t=e.key();C.hasOwnProperty(t)&&x.child(t).once("value",function(e){var r=null===e.val()?null:n(e.val()),i=null!==r?b(r):null;d(i)||v(t,r)})}function k(e){var n=E.indexOf(e);n>-1&&E.splice(n,1),j=0===E.length,j&&u()}function M(){var e=_(A,1e3*Q).map(c);e=e.filter(function(n,t){return e.indexOf(n)===t});for(var n=Object.keys(I),t=n.length,r=0;t>r;++r){var i=n[r],o=e.indexOf(i);-1===o?I[i].active=!1:(I[i].active=!0,e.splice(o,1))}F===!1&&Object.keys(I).length>25&&(F=!0,q=setTimeout(s,10)),E=e.slice(),e.forEach(function(e){var n=f(e),t=x.orderByChild("g").startAt(n[0]).endAt(n[1]),r=t.on("child_added",m),i=t.on("child_removed",w),o=t.on("child_changed",p),a=t.on("value",function(){t.off("value",a),k(e)});I[e]={active:!0,childAddedCallback:r,childRemovedCallback:i,childChangedCallback:o,valueCallback:a}}),0===e.length&&k()}if(this.center=function(){return A},this.radius=function(){return Q},this.updateCriteria=function(e){g(e),A=e.center||A,Q=e.radius||Q;for(var n=Object.keys(C),t=n.length,i=0;t>i;++i){var o=n[i],u=C[o],f=u.isInQuery;u.distanceFromCenter=r.distance(u.location,A),u.isInQuery=u.distanceFromCenter<=Q,f&&!u.isInQuery?a("key_exited",o,u.location,u.distanceFromCenter):!f&&u.isInQuery&&a("key_entered",o,u.location,u.distanceFromCenter)}j=!1,M()},this.on=function(e,n){if(-1===["ready","key_entered","key_exited","key_moved"].indexOf(e))throw new Error('event type must be "ready", "key_entered", "key_exited", or "key_moved"');if("function"!=typeof n)throw new Error("callback must be a function");if(O[e].push(n),"key_entered"===e)for(var r=Object.keys(C),i=r.length,o=0;i>o;++o){var a=r[o],u=C[a];"undefined"!=typeof u&&u.isInQuery&&n(a,u.location,u.distanceFromCenter)}return"ready"===e&&j&&n(),new t(function(){O[e].splice(O[e].indexOf(n),1)})},this.cancel=function(){O={ready:[],key_entered:[],key_exited:[],key_moved:[]};for(var e=Object.keys(I),n=e.length,t=0;n>t;++t){var r=e[t],i=f(r);l(i,I[r]),delete I[r]}C={},clearInterval(N)},"[object Object]"!==Object.prototype.toString.call(e))throw new Error("firebaseRef must be an instance of Firebase");var E,x=e,O={ready:[],key_entered:[],key_exited:[],key_moved:[]},j=!1,C={},I={},F=!1,q=null,N=setInterval(function(){F===!1&&s()},1e4);g(o,!0);var A=o.center,Q=o.radius;M()};return r}();"undefined"!=typeof module&&"undefined"!=typeof process&&(module.exports=GeoFire);